package main

import (
	"fmt"
	"reflect"

	_ "github.com/lib/pq"
	"xorm.io/xorm"
)

/*
table columns:
id        | bigint                 |           | not null | nextval('tbl_test_table_id_seq'::regclass)
name      | character varying(64)  |           |          |
full_name | character varying(128) |           |          |
summary   | character varying(200) |           |          |
status    | smallint               |           |          |
int_value | integer                |           |          |
*/

func main() {
	driver := "postgres"
	host := "localhost"
	port := 5432
	user := "fimatrix"
	password := ""
	dbName := "fimatrix"
	sslMode := "disable"

	connStr := fmt.Sprintf("%s://%s:%s@%s:%d/%s?sslmode=%s",
		driver, user, password, host, port, dbName, sslMode)

	engine, err := xorm.NewEngine(driver, connStr)

	items, err := engine.QueryInterface("select id, name, full_name, status, int_value from tbl_test_table")
	if err != nil {
		fmt.Printf("Error: %s\n", err)
	}
	fmt.Printf(">> items: %+v\n", items)

	if len(items) > 0 {
		item := items[0]

		typeOfValue := reflect.TypeOf(item["id"])
		fmt.Printf("column id type: %s, %s\n", typeOfValue.Name(), typeOfValue.Kind())

		typeOfValue = reflect.TypeOf(item["status"])
		fmt.Printf("column status type: %s, %s\n", typeOfValue.Name(), typeOfValue.Kind())

		typeOfValue = reflect.TypeOf(item["int_value"])
		fmt.Printf("column int_value type: %s, %s\n", typeOfValue.Name(), typeOfValue.Kind())
	}
}
